//----------------------------------------------------------------------
//  直接形Ⅱ IIR フィルタ，double 型を使用
//
//  2023/01/16, Copyright (c) 2023 MIKAMI, Naoki
//----------------------------------------------------------------------

#include "MultirateLiPh.hpp"
#include "IIR_Direct2D.hpp"
#include "Coefs_IIR6_DirectD_LP_300.hpp"
#pragma diag_suppress 870   // マルチバイト文字使用の警告抑制のため
using namespace Mikami;

const float FS_ = 10.0f;    // 入力の標本化周波数： 10 kHz
MultirateLiPh myAdDa_(FS_); // 出力標本化周波数を４倍にするオブジェクト
IirDirect2D df_(ORDER_, AK_, BK_);  // 直接形Ⅱ IIR フィルタのオブジェクト

// ADC 変換終了割込みに対する割込みサービス･ルーチン
void AdcIsr()
{
    float xn = myAdDa_.Input(); // 入力
    float yn = df_.Execute(xn); // 直接形Ⅱ IIR フィルタの処理
    myAdDa_.Output(yn);         // 出力
}

int main()
{
    printf("\r\n直接形Ⅱ IIR フィルタを実行します\r\n");
    printf("double 型を使用\r\n");

    myAdDa_.Start(&AdcIsr);     // 標本化を開始する
    while (true) {}
}
